
// COSDlg.h : header file
//

#pragma once

// Data:
struct TCOSData{
  unsigned char A,B,C;
};

class TIRQThread;

// CCOSDlg dialog
class CCOSDlg : public CDialogEx
{
// Construction
public:
	CCOSDlg(CWnd* pParent = NULL);	// standard constructor

	~CCOSDlg()    {	fclose(testtimefp); };


	// Funcs:
	void ReceiveGenIRQ(int CardNum);
	void ReceiveCOSData(int CardNum, TCOSData COSData[]);
	void AddLine(int CardNum, CString Line);
	void UpdateWDGUI(BOOL EnabWdg);
	void UpdateCOSUI();
    struct TCardData {
      unsigned long  Base;
      unsigned long  PPIs;
      bool           IsWDG;
      unsigned long  IRQCount;
      TCOSData   LastCOSData[10];
      CString         Log;
      unsigned long  WDGPets;
	};
	TCardData CardData[10];
	int WDGCardNum;
	void UpdateButtonUI();
	void UpdateAbortUI();
    
	// params:
	bool ThereCanBeOnlyOne;
	unsigned int WDGPetTimer;
	unsigned int WDGWaitTimer;
	void OnStopTimer();

	TIRQThread* Thrd;  
    CMutex m_mutex;
	
	bool bShutdown;

    FILE* testtimefp;   // timing output file


// Dialog Data
	enum { IDD = IDD_COS_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnCbnSelchangeComboCard();
	afx_msg void OnBnClickedBtnGeneric();
	afx_msg void OnBnClickedBtnCos();
	afx_msg void OnBnClickedBtnAbort();
	afx_msg void OnBnClickedCancel();
};
